(define gosper-step
  (lambda (side n)
    (adjoin
     (bend 15)
     side
     (bend -60)
     (gmirror (greverse side))
     (bend -120)
     (gmirror (greverse side))
     (bend 60)
     side
     (bend 120)
     side
     side
     (bend 60)
     (gmirror (greverse side))
     (bend -75))))

(define draw-gosper
  (lambda (n len)
    (if (= n 0)
        (straight len)
        (gosper-step (draw-gosper (- n 1) len) n))))

(define gosper
  (lambda (n)
    (adjoin
     (transparent 100)
     (bend -90)
     (transparent 100)
     (bend 180)
     (draw-gosper n (/ 20 n)))))
